'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _reactFlex = require('react-flex');

var _join = require('../utils/join');

var _join2 = _interopRequireDefault(_join);

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Cell = function (_Component) {
  _inherits(Cell, _Component);

  function Cell() {
    _classCallCheck(this, Cell);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Cell).apply(this, arguments));
  }

  _createClass(Cell, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      if (typeof nextProps.shouldComponentUpdate === 'function') {
        return nextProps.shouldComponentUpdate(nextProps, this.props);
      }

      return !(0, _shallowequal2.default)(nextProps, this.props);
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;

      var name = props.name;
      var data = props.data;
      var renderCell = props.render;
      var column = props.column;
      var cellDefaultClass = props.cellDefaultClass;
      var coumnDefaultClass = props.coumnDefaultClass;
      var value = props.value;


      var style = (0, _objectAssign2.default)({}, props.style);

      var baseClassName = column ? coumnDefaultClass : cellDefaultClass;
      var className = (0, _join2.default)(baseClassName, props.textAlign && baseClassName + '--align-' + props.textAlign, props.first && baseClassName + '--first', props.last && baseClassName + '--last');

      var minWidth = props.minWidth;
      var width = props.width;
      var maxWidth = props.maxWidth;

      if (width && minWidth && width < minWidth) {
        width = minWidth;
      }

      if (minWidth !== undefined) {
        style.minWidth = minWidth;
      }

      if (maxWidth !== undefined) {
        style.maxWidth = maxWidth;
      }

      if (width !== undefined) {
        style.minWidth = style.maxWidth = width;
      }

      var cellProps = (0, _objectAssign2.default)({}, props, {
        value: value,
        className: className,
        children: value,
        style: style
      });

      var result = undefined;
      if (renderCell) {
        result = renderCell(value, data, cellProps);
      }

      if (result === undefined) {
        result = _react2.default.createElement(_reactFlex.Item, _extends({}, cellProps, { data: null }));
      }

      return result;
    }
  }]);

  return Cell;
}(_reactClass2.default);

exports.default = Cell;


Cell.defaultProps = {
  cellDefaultClass: 'react-datagrid__cell',
  coumnDefaultClass: 'react-datagrid__column-header',
  minWidth: 40
};

Cell.propTypes = {
  style: _react.PropTypes.object,
  render: _react.PropTypes.func,
  data: _react.PropTypes.object,
  name: _react.PropTypes.string,
  width: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
  flex: function flex(props, propName) {
    var flex = props[propName];

    if (flex < 1 || flex > 24) {
      return new Error('Column flex prop expected to be between 1 and 24, got ' + flex);
    }
  },
  cellDefaultClass: _react.PropTypes.string
};