'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _reactDom = require('react-dom');

var _reactFlex = require('react-flex');

var _Column = require('../Column');

var _Column2 = _interopRequireDefault(_Column);

var _ColumnGroupHeader = require('./ColumnGroupHeader');

var _ColumnGroupHeader2 = _interopRequireDefault(_ColumnGroupHeader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Header = function (_Component) {
  _inherits(Header, _Component);

  function Header() {
    _classCallCheck(this, Header);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Header).apply(this, arguments));
  }

  _createClass(Header, [{
    key: 'render',
    value: function render() {
      var props = this.props;
      var columns = props.columns;
      var columnGroups = props.columnGroups;


      return _react2.default.createElement(
        _reactFlex.Flex,
        { wrap: false, row: true, alignItems: 'stretch', className: 'react-datagrid__header' },
        !!columnGroups ? this.renderColumnGroups(columnGroups) : this.renderColumnGroup(columns)
      );
    }
  }, {
    key: 'renderColumnGroup',
    value: function renderColumnGroup(columns) {
      return _react2.default.createElement(_ColumnGroupHeader2.default, { width: '100%', columns: columns });
    }
  }, {
    key: 'renderColumnGroups',
    value: function renderColumnGroups(columnGroups) {
      return _react2.default.Children.map(columnGroups, function (columnGroup, index) {
        var columnGroupProps = columnGroup.props;
        var children = columnGroupProps.children;


        var columns = undefined;
        if (children) {
          columns = children;
        } else {
          columns = columnGroupProps.columns.map(function (column) {
            return _react2.default.createElement(_Column2.default, column);
          });
        }

        return _react2.default.createElement(_ColumnGroupHeader2.default, { columns: columns });
      });
    }
  }]);

  return Header;
}(_reactClass2.default);

exports.default = Header;