'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Column = exports.ColumnGroup = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactClass = require('react-class');

var _reactClass2 = _interopRequireDefault(_reactClass);

var _reactFlex = require('react-flex');

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _join = require('./utils/join');

var _join2 = _interopRequireDefault(_join);

var _reactLoadMask = require('react-load-mask');

var _reactLoadMask2 = _interopRequireDefault(_reactLoadMask);

var _hasown = require('hasown');

var _hasown2 = _interopRequireDefault(_hasown);

var _Header = require('./Header');

var _Header2 = _interopRequireDefault(_Header);

var _Body = require('./Body');

var _Body2 = _interopRequireDefault(_Body);

var _ColumnGroup = require('./Body/ColumnGroup');

var _ColumnGroup2 = _interopRequireDefault(_ColumnGroup);

require('react-load-mask/index.css');

var _rowSelect = require('./rowSelect');

var _rowSelect2 = _interopRequireDefault(_rowSelect);

var _Column = require('./Column');

var _Column2 = _interopRequireDefault(_Column);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SCREEN_HEIGHT = global.screen && global.screen.height;

var DataGrid = function (_Component) {
  _inherits(DataGrid, _Component);

  function DataGrid(props) {
    _classCallCheck(this, DataGrid);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(DataGrid).call(this, props));

    var selected = props.selected;

    var isLoading = props.dataSource && !!props.dataSource.then;

    _this.state = {
      loading: isLoading,
      data: false,
      selected: props.defaultSelected
    };
    return _this;
  }

  _createClass(DataGrid, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var dataGridNode = (0, _reactDom.findDOMNode)(this.refs.dataGrid);

      // load data
      this.loadSourceData(this.props.dataSource, this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps, nextState) {
      // if data changed
      if (this.p.dataSource !== nextProps.dataSource) {
        this.loadSourceData(nextProps.dataSource, nextProps);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var preparedProps = this.p = this.prepareProps(this.props, this.state);

      var dataSource = preparedProps.dataSource;
      var columns = preparedProps.columns;
      var hideHeader = preparedProps.hideHeader;
      var onRowMouseEnter = preparedProps.onRowMouseEnter;
      var onRowMouseLeave = preparedProps.onRowMouseLeave;
      var onScrollBottom = preparedProps.onScrollBottom;
      var loading = preparedProps.loading;
      var data = preparedProps.data;
      var isMultiselect = preparedProps.isMultiselect;
      var selected = preparedProps.selected;
      var className = preparedProps.className;
      var hasSelection = preparedProps.hasSelection;
      var children = preparedProps.children;
      var contentHeight = preparedProps.contentHeight;


      return _react2.default.createElement(
        _reactFlex.Flex,
        _extends({}, preparedProps, {
          column: true,
          flex: true,
          alignItems: 'stretch',
          className: className,
          ref: 'dataGrid'
        }),
        loading && this.renderLoadMask(),
        !hideHeader && _react2.default.createElement(_Header2.default, {
          columns: columns,
          columnGroups: children
        }),
        _react2.default.createElement(_Body2.default, _extends({}, preparedProps, {
          isMultiselect: isMultiselect,
          hasSelection: hasSelection,
          columns: columns,
          data: data,
          loading: loading,
          contentHeight: contentHeight,
          onRowMouseEnter: onRowMouseEnter,
          onRowMouseLeave: onRowMouseLeave,
          onScrollBottom: onScrollBottom,
          selected: selected,
          onRowClick: this.onRowClick
        }))
      );
    }
  }, {
    key: 'renderLoadMask',
    value: function renderLoadMask() {
      return _react2.default.createElement(_reactLoadMask2.default, {
        visible: true,
        className: 'react-datagrid__load-mask'
      });
    }
  }, {
    key: 'onRowClick',
    value: function onRowClick(event, rowProps) {
      this.handleSelection(rowProps, event);
    }
  }, {
    key: 'loadSourceData',
    value: function loadSourceData(dataSource, props) {
      var _this2 = this;

      if (dataSource === null) {
        this.setData(null);
        return;
      }

      if (Array.isArray(dataSource)) {
        this.setData(dataSource);
      }

      if (dataSource.then) {
        if (props.onDataSourceResponse) {
          dataSource.then(props.onDataSourceResponse, props.onDataSourceResponse);
        }

        this.setState({
          loading: true
        });

        dataSource.then(function (data) {
          if (!Array.isArray(data)) {
            throw new Error('dataSource Promise did not return an array, it returned a ' + (typeof data === 'undefined' ? 'undefined' : _typeof(data)));
          }

          _this2.setData(data);
        });
      }
    }
  }, {
    key: 'setData',
    value: function setData(data) {
      var _this3 = this;

      var props = this.props;
      var selected = props.selected;
      var defaultSelected = props.defaultSelected;
      var onSelectionChange = props.onSelectionChange;


      var newDataState = {
        data: data,
        loading: false
      };

      // make dataMap only if selected is used
      if (this.isSelectionEnabled() && data !== null) {
        newDataState.dataMap = data.reduce(function (acc, item) {
          acc[_this3.getItemId(item)] = item;
          return acc;
        }, {});
      }

      this.setState(newDataState);
    }
  }, {
    key: 'getItemId',
    value: function getItemId(item) {
      return item[this.props.idProperty];
    }
  }, {
    key: 'getSelected',
    value: function getSelected() {
      return this.isSelectionControlled() ? this.props.selected : this.state.selected;
    }
  }, {
    key: 'isSelectionControlled',
    value: function isSelectionControlled() {
      return this.props.selected !== undefined;
    }
  }, {
    key: 'isSelectionEnabled',
    value: function isSelectionEnabled() {
      var selected = this.props.selected;
      var defaultSelected = this.props.defaultSelected;

      return selected !== undefined || defaultSelected !== undefined;
    }
  }, {
    key: 'isSelectionEmptry',
    value: function isSelectionEmptry() {
      var selected = this.getSelected();
      var selectionEmptry = false;

      if (selected === undefined) {
        selectionEmptry = true;
      }

      if ((typeof selected === 'undefined' ? 'undefined' : _typeof(selected)) === 'object' && selected !== null) {
        selectionEmptry = Object.keys(selected).length === 0;
      }

      return selectionEmptry;
    }
  }, {
    key: 'prepareProps',
    value: function prepareProps(props, state) {
      var loading = props.loading == undefined ? this.state.loading : props.loading;

      var selected = this.getSelected();
      var hasSelection = !this.isSelectionEmptry();
      var contentHeight = props.rowHeight * (state.data ? state.data.length : 0);
      var isMultiselect = (typeof selected === 'undefined' ? 'undefined' : _typeof(selected)) === 'object' && selected !== null;

      var className = (0, _join2.default)(props.className, 'react-datagrid');

      return (0, _objectAssign2.default)({}, props, {
        loading: loading,
        selected: selected,
        hasSelection: hasSelection,
        contentHeight: contentHeight,
        isMultiselect: isMultiselect,
        className: className,
        data: state.data
      });
    }
  }]);

  return DataGrid;
}(_reactClass2.default);

DataGrid.defaultProps = {
  defaultLoading: true,
  hideHeader: false,
  onRowMouseEnter: function onRowMouseEnter() {},
  onRowMouseLeave: function onRowMouseLeave() {},
  onScrollBottom: function onScrollBottom() {},
  rowProps: {},
  defaultSelected: undefined
};

DataGrid.propTypes = {
  loading: _react2.default.PropTypes.bool,
  idProperty: _react2.default.PropTypes.string.isRequired,

  columns: _react.PropTypes.arrayOf(function (props, propName) {
    var column = props[propName];

    if (!column.name && typeof column.render != 'function') {
      return new Error('column ' + propName + ' should have a "name" prop or a "render" function!');
    }
  }),

  dataSource: function dataSource(props, propName) {
    var dataSource = props[propName];

    if (dataSource === undefined) {
      return new Error('dataSource prop is required.');
    }

    if (dataSource !== null && !Array.isArray(dataSource) && !(dataSource && dataSource.then)) {
      return new Error('dataSource must be an array, null or a promise.');
    }
  },

  onDataSourceResponse: _react.PropTypes.func,
  children: function children(props, propName) {
    var children = props[propName];

    _react2.default.Children.map(children, function (child) {
      if (!child || !child.props || !child.props.isColumnGroup || !child.props.isColumn) {
        return new Error('The only children allowed of Datagrid are ColumnGroup and Column');
      }
    });
  },

  onScroll: _react.PropTypes.func,
  hideHeader: _react.PropTypes.bool,
  onRowMouseEnter: _react.PropTypes.func,
  onRowMouseLeave: _react.PropTypes.func,
  onScrollBottom: _react.PropTypes.func,

  selected: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string, _react.PropTypes.object]),
  defaultSelected: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string, _react.PropTypes.object]),
  onSelectionChange: _react.PropTypes.func
};

DataGrid.prototype = (0, _objectAssign2.default)(DataGrid.prototype, _rowSelect2.default);

exports.default = DataGrid;

// Column is a dummy componnet only used for configuration

exports.ColumnGroup = _ColumnGroup2.default;
exports.Column = _Column2.default;